import javax.microedition.lcdui.*;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import javax.microedition.io.HttpConnection;
import javax.microedition.io.Connector;

class Lib_im {
    public static Image image_from_url(String url) {
      HttpConnection http = null;
      DataInputStream dis = null;
      try{
        http = (HttpConnection) Connector.open(url);
        http.setRequestProperty("User-Agent", "MIDletPascal");
        int rc = http.getResponseCode();
        if (rc == HttpConnection.HTTP_OK) {
          dis = http.openDataInputStream();
          byte imageData[];
          int len = (int) http.getLength();
          if (len != -1) {
            imageData = new byte[len];
            dis.readFully(imageData);
          }
          else { // Length not available...
            ByteArrayOutputStream bStrm = new ByteArrayOutputStream();
            int ch;
            while ( (ch = dis.read()) != -1)
              bStrm.write(ch);
            imageData = bStrm.toByteArray();
            bStrm.close();
          }
          return Image.createImage(imageData, 0, imageData.length);
        }else{
          System.out.println("Code: "+http.getResponseMessage());
          return null;
        }
      }catch(Exception ex) {ex.printStackTrace(); return null;}
    }

	public static Image image_from_string(String source) {
		return Image.createImage(source.getBytes(), 0, source.length());
	}
}
